#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/time.h>
#include <string.h>

// microtime returns current time as double
double microtime() {
	int err;
	struct timeval tv;

	err = gettimeofday(&tv, NULL);
	if (err == -1) {
		perror("gettimeofday");
		abort();
	}

	return tv.tv_sec + 1E-6 * tv.tv_usec;
}

//		 12345678
#define	NITER	1000000

#define	BUFSIZE	4096
static char buf[BUFSIZE];
static char buf2[BUFSIZE];

int main() {
	int i;
	size_t size;

	for (size = 0; size <= BUFSIZE;) {
		// warmup
		memcpy(buf2, buf, size);

		double Tstart, Tend;
		Tstart = microtime();

		for (i = 0; i < NITER; i++) {
			memcpy(buf2, buf, size);
		}

		Tend = microtime();

		printf("%ld\t%.1f\n", size, (Tend - Tstart) / NITER / 1E-9);


		if (size < 16) {
			size += 1;	// detailed start
		} else if  (size < 128) {
			size += 16;
		} else {
			size += 128;
		}
	}
}
