package main

import (
	"fmt"
	"time"
)

//             12345678
const Niter = 1000000

const BufSize = 4096
var buf  [BufSize]byte
var buf2 [BufSize]byte

func main() {
	for size := 0; size <= BufSize; {
		src := buf[:size]
		dst := buf2[:size]

		// warmup
		copy(dst, src)

		Tstart := time.Now()

		for i := 0; i < Niter; i++ {
			copy(dst, src)
		}

		Tend := time.Now()

		fmt.Printf("%v\t%.1f\n", size, float64(Tend.Sub(Tstart).Nanoseconds()) / Niter)

		switch {
		case size < 16:
			size += 1	// detailed start
		case size < 128:
			size += 16
		default:
			size += 128
		}
	}
}
